classification
Title: Webserver TypeError: expected read buffer, NoneType found
Type: enhancement Stage: test needed
Components: Library (Lib) Versions: Python 3.1, Python 2.7
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: Nosy List: BreamoreBoy, jbeisert, jimjjewett, whit537
Priority: low Keywords: patch

Created on 2006-07-19 14:53 by jbeisert, last changed 2010-08-25 14:44 by BreamoreBoy. This issue is now closed.

Messages (7)
msg60943 - (view) Author: jbet (jbeisert) Date: 2006-07-19 14:53
When I'm using the python webserver I got the 
following message for every access by my client. 
Soryy, I have no experience in Python, so I cannot 
help. This is only a report. 
  
HTTPdaemon_v1.0.0 listening on port 8001 
---------------------------------------- 
Exception happened during processing of request from 
('192.168.1.9', 33917) 
Traceback (most recent call last): 
  File "/home/jb/bin/lib/python2.5/SocketServer.py", 
line 463, in  
process_request_thread 
    self.finish_request(request, client_address) 
  File "/home/jb/bin/lib/python2.5/SocketServer.py", 
line 254, in  
finish_request 
    self.RequestHandlerClass(request, client_address, 
self) 
  File "/home/jb/bin/lib/python2.5/SocketServer.py", 
line 521, in __init__ 
    self.handle() 
  File 
"/home/jb/bin/lib/python2.5/BaseHTTPServer.py", line 
316, in handle 
    self.handle_one_request() 
  File 
"/home/jb/bin/lib/python2.5/BaseHTTPServer.py", line 
310, in  
handle_one_request 
    method() 
  File 
"./src/Myghty-1.0/lib/myghty/http/HTTPServerHandler.py", 
line 53, in  
do_GET 
    self.handle_request() 
  File 
"./src/Myghty-1.0/lib/myghty/http/HTTPServerHandler.py", 
line 56, in  
handle_request 
    httpreq = HSHTTPRequest(self) 
  File 
"./src/Myghty-1.0/lib/myghty/http/HTTPServerHandler.py", 
line 254, in  
__init__ 
    keep_blank_values = True 
  File "/home/jb/bin/lib/python2.5/cgi.py", line 462, 
in __init__ 
    fp = StringIO(qs) 
TypeError: expected read buffer, NoneType found 
---------------------------------------- 
---------------------------------------- 
Exception happened during processing of request from 
('192.168.1.9', 33918) 
Traceback (most recent call last): 
  File "/home/jb/bin/lib/python2.5/SocketServer.py", 
line 463, in  
process_request_thread 
    self.finish_request(request, client_address) 
  File "/home/jb/bin/lib/python2.5/SocketServer.py", 
line 254, in  
finish_request 
    self.RequestHandlerClass(request, client_address, 
self) 
  File "/home/jb/bin/lib/python2.5/SocketServer.py", 
line 521, in __init__ 
    self.handle() 
  File 
"/home/jb/bin/lib/python2.5/BaseHTTPServer.py", line 
316, in handle 
    self.handle_one_request() 
  File 
"/home/jb/bin/lib/python2.5/BaseHTTPServer.py", line 
310, in  
handle_one_request 
    method() 
  File 
"./src/Myghty-1.0/lib/myghty/http/HTTPServerHandler.py", 
line 53, in  
do_GET 
    self.handle_request() 
  File 
"./src/Myghty-1.0/lib/myghty/http/HTTPServerHandler.py", 
line 56, in  
handle_request 
    httpreq = HSHTTPRequest(self) 
  File 
"./src/Myghty-1.0/lib/myghty/http/HTTPServerHandler.py", 
line 254, in  
__init__ 
    keep_blank_values = True 
  File "/home/jb/bin/lib/python2.5/cgi.py", line 462, 
in __init__ 
    fp = StringIO(qs) 
TypeError: expected read buffer, NoneType found 
---------------------------------------- 
msg60944 - (view) Author: Chad Whitacre (whit537) Date: 2006-08-01 19:04
Logged In: YES 
user_id=340931

Thanks for the report. Can I ask how you came to use the
as-yet-unreleased Python 2.5 if you have no experience with
Python? It looks like you are having this problem with
Myghty. Does that require Python 2.5? 

FWIW, this looks to me like a problem with Myghty's use of
the cgi module, not a problem with Python itself.
msg60945 - (view) Author: Jim Jewett (jimjjewett) Date: 2006-08-02 22:04
Logged In: YES 
user_id=764593

I suspect that changing 

>>> fp = StringIO(qs)

to 

>>> fp = StringIO(qs or "")

would fix the problem.

If so, this is arguably a bug in myghty.  qs was already 
set to "" unless sys.argv[1] or environ['QUERY_STRING']had 
a value.  Neither of these should ever be None.  (They 
should be either a string, or not found.)
msg60946 - (view) Author: jbet (jbeisert) Date: 2006-08-03 07:39
Logged In: YES 
user_id=1558389

> Can I ask how you came to use the 
> as-yet-unreleased Python 2.5 if 
> you have no experience with Python? 
 
We are using Myghty as a webserver, but we have the 
problem python 2.4 eats up all the memory of the small 
embedded system. So I tried with python 2.5 with the new 
memory management...and was stuck at this message. 
I reported this message to improve 2.5 development. Sorry 
if this was a wrong way to do it. 
msg60947 - (view) Author: Jim Jewett (jimjjewett) Date: 2006-08-03 14:18
Logged In: YES 
user_id=764593

This was a fine place to report it; the question is how to 
resolve it now that it is reported.  The catch is that 
cgi.py doesn't seem to have changed, and we're not sure it 
should.
msg114806 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2010-08-24 19:27
Can this be closed as there is some doubt as to whether or not this is a Python problem?
msg114917 - (view) Author: Mark Lawrence (BreamoreBoy) * Date: 2010-08-25 14:44
Hi Mark,

due to:

Failed issue tracker submission
You are not a registered user.

I send the mail to your private account.

Long time ago. I think you can close it.

Regards,
Juergen
History
Date User Action Args
2010-08-25 14:44:54BreamoreBoysetstatus: open -> closed
resolution: out of date
messages: + msg114917
2010-08-24 19:27:58BreamoreBoysetnosy: + BreamoreBoy
messages: + msg114806
2009-03-30 04:49:06ajaksu2setpriority: normal -> low
keywords: + patch
stage: test needed
type: enhancement
versions: + Python 3.1, Python 2.7, - Python 2.5
2006-07-19 14:53:29jbeisertcreate